﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using LeanCloud;
using System.Threading.Tasks;
using System.Threading;

public class Hello : MonoBehaviour
{
    // Start is called before the first frame update
    void Start()
    {
        AVClient.HttpLog(Debug.Log);

        //TestUpdateLeaderboard();

        //TestGetStatistics();

        //TestGetResults();

        TestGetResultsOfMe();
    }

    void TestUpdateLeaderboard() {
        AVUser.LogInAsync("1", "1").ContinueWith(t => {
            if (t.IsFaulted) {
                throw t.Exception.InnerException;
            }
            return Leaderboard.UpdateStatistics(AVUser.CurrentUser, new List<Statistic> { new Statistic("leaderboard_1", 5) });
        }).Unwrap().ContinueWith(t => { 
            if (t.IsFaulted) {
                Debug.LogError(t.Exception.InnerException.Message);
            } else {
                Debug.Log(t.Result);
            }
        });
    }

    //void TestGetStatistics() {
    //    AVUser.LogInAsync("1", "1").ContinueWith(t => {
    //        if (t.IsFaulted) {
    //            throw t.Exception.InnerException;
    //        }
    //        return Leaderboard.GetStatistics(AVUser.CurrentUser);
    //    }).Unwrap().ContinueWith(t => {
    //        if (t.IsFaulted) {
    //            Debug.LogError(t.Exception.InnerException.Message);
    //        } else {
    //            Debug.Log(t.Result);
    //        }
    //    });
    //}

    void TestGetResults() {
        var leaderboard = Leaderboard.CreateWithoutData("leaderboard_1");
        leaderboard.GetResults().ContinueWith(t => { 
            if (t.IsFaulted) {
                Debug.LogError(t.Exception.InnerException.Message);
                return;
            }
            Debug.Log(t.Result);
        });
    }

    void TestGetResultsOfMe() {
        AVUser.LogInAsync("1", "1").ContinueWith(t => {
            if (t.IsFaulted) {
                throw t.Exception.InnerException;
            }
            var leaderboard = Leaderboard.CreateWithoutData("leaderboard_1");
            return leaderboard.GetResultsAroundUser();
        }).Unwrap().ContinueWith(t => {
            if (t.IsFaulted) {
                Debug.LogError(t.Exception.InnerException.Message);
            } else {
                Debug.Log(t.Result);
            }
        });
    }
}
